#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <syslog.h>
#include <errno.h>
#include <pwd.h>
#include <fcntl.h>
#include <stdio.h>
#include <sys/wait.h>
#include <signal.h>

#if defined(linux) && !defined(SIGHUP)
#define        SIGHUP          1       /* Hangup (POSIX).  */
#endif

#include "str.h"
#include "pset.h"

#include "options.h"

#include "attr.h"
#include "server.h"
#include "state.h"
#include "sconst.h"
#include "config.h"

#ifdef sun
#include <sys/signal.h>
#endif

#define MAX_ADDR 80
#define MAX_CMD 100

/* Do the redirection of a service */
/* This function gets called from child.c after we have been forked */
void admin_handler( struct server *serp )
{
	struct service *sp = SERVER_SERVICE( serp );
	struct service_config *scp = SVC_CONF( sp );
	int descriptor = SERVER_FD( serp );
	char *adr;
	static char lastaddr[MAX_ADDR];
	char cmd[MAX_CMD]; 
	char *buffer, *rettok;
	int u, red;
	
	while(1)
	{
		Sprint(descriptor, "> ");
		Sflush();
		bzero(cmd, MAX_CMD);
		bzero(cmd, MAX_CMD);
		red = read(descriptor, cmd, MAX_CMD);
		if( red < 0 )
		{
			perror("reading command");
			exit(1);
		}

		if( red == 0 )
			exit(0);

	  if((strstr(cmd, "bye") != NULL) || (strstr(cmd, "exit") != NULL))
	  {
		  Sprint(descriptor, "bye bye\n");
		  Sflush();
		  exit(0);
	  }

     if( strstr(cmd, "help") != NULL ) 
     {
        Sprint(descriptor, "xinetd admin help:\n");
        Sprint(descriptor, "show run  :   shows information about running services\n");
        Sprint(descriptor, "show avail:   shows what services are currently available\n");
        Sprint(descriptor, "bye, exit :   exits the admin shell\n");
     }

	  if( strstr(cmd, "show") != NULL )
	  {
		  if( strstr(cmd, "run") != NULL )
		  {
			  Sprint(descriptor, "Running services:\n");
           Sprint(descriptor, "service  run retry attempts descriptor\n");
			  for( u = 0 ; u < pset_count( SERVERS( ps ) ) ; u++ )
			  {
				  struct service *sp = 
					(SERP( pset_pointer( SERVERS(ps), u ) ))->svr_sp;
  
				  Sprint(descriptor, "%-10s %-3d %-5d %-7d %-5d\n", 
					(char *)SVC_ID( sp ), sp->svc_running_servers+1, 
					sp->svc_retry_servers, sp->svc_attempts, sp->svc_fd );
			  }
		  }
		  else if( strstr(cmd, "avail") != NULL )
		  {
			  Sprint(descriptor, "Available services:\n");
			  for( u = 0 ; u < pset_count( SERVICES( ps ) ) ; u++ )
			  {
				  struct service *sp;
				  sp = SP( pset_pointer( SERVICES( ps ), u ) );
  
				 Sprint(descriptor, "%s\n", SC_NAME( SVC_CONF( sp ) ) );
			  }
		  }
		  else
		  {
			  Sprint(descriptor, "Relevant commands:\n");
			  Sprint(descriptor, "run   : Show currently running servers\n");
			  Sprint(descriptor, "avail : Show currently available servers\n");
		  }
	  }
  }
	Sprint(descriptor, "exiting\n");
	Sflush();
	exit(0);
}
